package handlers

import (
	"net/http"

	"easydo-echo_win7/models"
	"easydo-echo_win7/services"
	"easydo-echo_win7/utils"

	"easydo-echo_win7/middleware"

	"github.com/jmoiron/sqlx"
	"github.com/labstack/echo-contrib/session"
	"github.com/labstack/echo/v4"
)

func Add_outsourcing_plan_to_routes(e *echo.Echo) {
	group := e.Group("/outsourcingPlan")
	group.Use(middleware.AuthMiddleware)
	group.POST("/getPage", outsourcingPlanGetPage)
	group.POST("/getList", outsourcingPlanGetList)
	group.POST("/save", outsourcingPlanSave)
	group.POST("/update", outsourcingPlanUpdate)
	group.POST("/remove", outsourcingPlanRemove)

}

func outsourcingPlanGetPage(c echo.Context) error {
	var paramMap map[string]interface{}
	if err := c.Bind(&paramMap); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}
	result, err := services.JdbcClient.GetJdbcPage(paramMap, models.OutsourcingPlan{})
	if err != nil {
		utils.PrintSqlErr(err)
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
	}
	list := utils.ConvertInterface[[]models.OutsourcingPlan](result.Records)
	if len(list) == 0 {
		list = []models.OutsourcingPlan{}
	}
	for i := range list {
		model := list[i]
		minioList, err := services.JdbcClient.GetMinioFile(model)
		if err != nil {
			utils.PrintSearchFileErr(err)
		}
		model.FileList = &minioList

		sale_order := new(models.SaleOrder)
		sale_order.ID = model.SaleOrderId
		err = services.JdbcClient.GetJdbcModelById(sale_order)
		if err != nil {
			utils.PrintSqlErr(err)
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
		}
		model.SaleOrder = sale_order

		detailParam := new(models.OutsourcingPlanDetail)
		detailParam.PlanId = model.ID
		result, err := services.JdbcClient.GetJdbcListByObject(detailParam)
		if err != nil {
			utils.PrintSqlErr(err)
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
		}
		detail_list := utils.ConvertInterface[[]models.OutsourcingPlanDetail](result)

		for j := range detail_list {
			detail := detail_list[j]

			material := new(models.ProductMaterial)
			material.Code = detail.MaterialCode
			err = services.JdbcClient.GetJdbcModel(material)
			if err != nil {
				utils.PrintSqlErr(err)
				return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
			}

			detail.ProductMaterial = material

			detail_list[j] = detail
		}
		model.ChildrenList = &detail_list

		list[i] = model
	}
	result.Records = list
	return c.JSON(http.StatusOK, result)

}

func outsourcingPlanGetList(c echo.Context) error {
	var paramMap map[string]interface{}
	if err := c.Bind(&paramMap); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}
	result, err := services.JdbcClient.GetJdbcList(paramMap, models.OutsourcingPlan{})
	if err != nil {
		utils.PrintSqlErr(err)
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", err.Error()))
	}
	list := utils.ConvertInterface[[]models.OutsourcingPlan](result)
	if len(list) == 0 {
		return c.JSON(http.StatusOK, []string{})
	}
	return c.JSON(http.StatusOK, list)
}

func outsourcingPlanSave(c echo.Context) error {
	tx, _ := services.MYSQL_DB.Beginx()

	sess, _ := session.Get("auth_session", c)
	user_id, ok := sess.Values["user_id"].(int64)
	if !ok {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("用户请先登录", ""))
	}
	plan := new(models.OutsourcingPlan)
	if err := c.Bind(plan); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}
	err_msg := outsourcingPlan_generateCode(plan, tx)
	if err_msg != "" {
		tx.Rollback()
		return c.JSON(http.StatusBadRequest, utils.ErrorResponse(err_msg, ""))
	}
	status := models.Outsourcing_Plan_Status_Pending
	plan.Status = &status
	plan.CreateId = &user_id
	services.JdbcClient.JdbcInsert(plan, tx)

	detail_list := *plan.ChildrenList
	for _, detail := range detail_list {
		detail.PlanId = plan.ID
		err := services.JdbcClient.JdbcInsert(&detail, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}

	if plan.FileList == nil {
		tx.Commit()
		return c.JSON(http.StatusOK, plan)
	}
	fileList := *plan.FileList
	for _, file := range fileList {
		file.RefId = plan.ID
		refType := models.File_Ref_Type_Outsourcing_Plan
		file.RefType = &refType

		err := services.JdbcClient.JdbcInsert(&file, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}
	tx.Commit()
	return c.JSON(http.StatusOK, plan)

}

func outsourcingPlanUpdate(c echo.Context) error {
	tx, _ := services.MYSQL_DB.Beginx()

	plan := new(models.OutsourcingPlan)
	if err := c.Bind(plan); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}
	sess, _ := session.Get("auth_session", c)
	user_id, ok := sess.Values["user_id"].(int64)
	if !ok {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("用户请先登录", ""))
	}
	plan.UpdateId = &user_id
	err := services.JdbcClient.JdbcUpdateById(plan, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	detail := new(models.OutsourcingPlanDetail)
	detail.PlanId = plan.ID
	err = services.JdbcClient.JdbcRemove(detail, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	detail_list := *plan.ChildrenList
	for _, detail := range detail_list {
		detail.PlanId = plan.ID
		err := services.JdbcClient.JdbcInsert(&detail, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}

	if plan.FileList == nil {
		tx.Commit()
		return c.JSON(http.StatusOK, plan)
	}

	fileList := *plan.FileList
	for _, file := range fileList {
		file.RefId = plan.ID
		refType := models.File_Ref_Type_Outsourcing_Plan
		file.RefType = &refType

		err := services.JdbcClient.JdbcInsert(&file, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			tx.Rollback()
			return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
		}
	}

	tx.Commit()
	return c.JSON(http.StatusOK, plan)
}

func outsourcingPlanRemove(c echo.Context) error {
	tx, _ := services.MYSQL_DB.Beginx()

	plan := new(models.OutsourcingPlan)
	if err := c.Bind(plan); err != nil {
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("参数解析失败", err.Error()))
	}

	err := services.JdbcClient.JdbcRemoveById(plan, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	minio_file := new(models.MinioFile)
	minio_file.RefId = plan.ID
	refType := models.File_Ref_Type_Outsourcing_Plan
	minio_file.RefType = &refType
	err = services.JdbcClient.JdbcRemove(minio_file, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	detail := new(models.OutsourcingPlanDetail)
	detail.PlanId = plan.ID
	err = services.JdbcClient.JdbcRemove(detail, tx)
	if err != nil {
		utils.PrintSqlErr(err)
		tx.Rollback()
		return c.JSON(http.StatusInternalServerError, utils.ErrorResponse("系统错误", ""))
	}

	tx.Commit()
	return c.JSON(http.StatusOK, plan)
}

func outsourcingPlan_generateCode(model *models.OutsourcingPlan, tx *sqlx.Tx) string {
	sync := new(models.Synchronized)
	sync.Sync.Lock()
	defer sync.Sync.Unlock()

	if model.Code != nil && len(*model.Code) > 0 {
		modelParam := new(models.OutsourcingPlan)
		modelParam.Code = model.Code
		modelParam.TenantId = model.TenantId
		count, err := services.JdbcClient.GetJdbcCount(modelParam, tx)
		if err != nil {
			utils.PrintSqlErr(err)
			return "SQL执行失败"
		}
		if count > 0 {
			return "编号已存在，请重新填写"
		}
	} else {
		for {
			code, err := services.GetFlowNo(models.Flow_No_Type_Outsourcing_Plan, *model.TenantId, tx)
			if err != nil {
				return "自动生成编码失败"
			}
			modelParam := new(models.OutsourcingPlan)
			modelParam.Code = &code
			modelParam.TenantId = model.TenantId
			count, err := services.JdbcClient.GetJdbcCount(modelParam, tx)
			if err != nil {
				utils.PrintSqlErr(err)
				return "SQL执行失败"
			}
			if count == 0 {
				model.Code = &code
				break
			}
		}

	}
	return ""
}
